package com.malk.lingmingguangzi.service;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
@Slf4j
public class LingmingguangziServiceImpl implements LingmingguangziService {
    @Autowired
    private YDClient ydClient;

    @Autowired
    private YDConf ydConf;

    @Override
    public McR test() {
        log.info("test");
        return McR.success();
    }

    @Override
    public McR getCustomerQuestionnaireCount(Long start, Long end) {
        YDParam.YDParamBuilder ydParamBuilder = YDParam.builder()
                .formUuid("FORM-5CC9748D283C49FC8C8A86EE0529730A4I1D");

        YDParam.YDParamBuilder ydParamBuilder2 = YDParam.builder()
                .formUuid("FORM-36BF81FD5E43496FABB060190302A7615WBT");

        YDParam.YDParamBuilder ydParamBuilder3 = YDParam.builder()
                .formUuid("FORM-7AB4677010554E81BAA0AC26A46F1940PTIR");

        YDParam.YDParamBuilder ydParamBuilder4 = YDParam.builder()
                .formUuid("FORM-06A0188FF4E840CA82CBE51604C8C0D6SYTU");

        if (start != null && end != null){
            String startDate = DateUtil.format(new Date(start), "yyyy-MM-dd HH:mm:ss");
            String endDate = DateUtil.format(DateUtil.offsetDay(new Date(end),1), "yyyy-MM-dd HH:mm:ss");

            ydParamBuilder.createFromTimeGMT(startDate);
            ydParamBuilder.createToTimeGMT(endDate);

            ydParamBuilder2.createFromTimeGMT(startDate);
            ydParamBuilder2.createToTimeGMT(endDate);

            ydParamBuilder3.createFromTimeGMT(startDate);
            ydParamBuilder3.createToTimeGMT(endDate);

            ydParamBuilder4.createFromTimeGMT(startDate);
            ydParamBuilder4.createToTimeGMT(endDate);
        }

        //车载--------------------------------------------
        DDR_New ddrNew = ydClient.queryData(ydParamBuilder.build(), YDConf.FORM_QUERY.retrieve_list);
        List<Map> dataList = (List<Map>) ddrNew.getData();
        int importantCustomerCount = 0;
        int orderCustomerCount = 0;
        int strategicCustomerCount = 0;

        for (Map data : dataList) {
            Map formData = (Map) data.get("formData");
            String customerLevel = String.valueOf(formData.get("selectField_lx4g7em6"));
            switch (customerLevel){
                case "重要客户": importantCustomerCount++; break;
                case "订单客户": orderCustomerCount++; break;
                case "战略客户": strategicCustomerCount++; break;
            }
        }

        Map<String,Integer> result = new HashMap<>();
        result.put("importantCustomerCount", importantCustomerCount);
        result.put("orderCustomerCount", orderCustomerCount);
        result.put("strategicCustomerCount", strategicCustomerCount);

        //消费----------------------------------------------
        Set<String> customerSet = new HashSet<>();
        //商务端
        DDR_New ddrNew1 = ydClient.queryData(ydParamBuilder2.build(), YDConf.FORM_QUERY.retrieve_list);
        List<Map> dataList1 = (List<Map>) ddrNew1.getData();

        for (Map data : dataList1) {
            Map formData = (Map) data.get("formData");
            String customer = String.valueOf(formData.get("textField_lwq1vxnj"));
            System.out.println(customer);
            customerSet.add(customer);
        }

        //技术端
        DDR_New ddrNew2 = ydClient.queryData(ydParamBuilder3.build(), YDConf.FORM_QUERY.retrieve_list);
        List<Map> dataList2 = (List<Map>) ddrNew2.getData();

        for (Map data : dataList2) {
            Map formData = (Map) data.get("formData");
            String customer = String.valueOf(formData.get("textField_lwq1vxnj"));
            System.out.println(customer);
            customerSet.add(customer);
        }

        //质量端
        DDR_New ddrNew3 = ydClient.queryData(ydParamBuilder4.build(), YDConf.FORM_QUERY.retrieve_list);
        List<Map> dataList3 = (List<Map>) ddrNew3.getData();

        for (Map data : dataList3) {
            Map formData = (Map) data.get("formData");
            String customer = String.valueOf(formData.get("textField_lwq1vxnj"));
            System.out.println(customer);
            customerSet.add(customer);
        }
        result.put("consumption",customerSet.size());

        return McR.success(result);
    }
}
